dnl
dnl $Id: config.m4
dnl

PHP_ARG_WITH(magickwand, for Magickwand support,
[  --with-magickwand[=DIR] Include Magickwand support], no)


if test "$PHP_MAGICKWAND" != "no"; then

  MAGICK_NAME="ImageMagick / MagickWand"
  NEEDED_VERSION=6003003
  NEEDED_VERSION_STRING=6.3.3
  CONFIG_NAME="Wand-config"

  LIB_NAME="Wand"
  CHECK_FUNC="MagickSetImageTicksPerSecond"

  AC_DEFINE(MAGICKWAND_BACKEND, "ImageMagick", [ ])
  AC_MSG_RESULT(Building with ImageMagick as backend)

  if test -r $PHP_MAGICKWAND/include/wand/magick-wand.h; then
    AC_MSG_CHECKING(for $MAGICK_NAME in provided path)
    IMAGEMAGICK_DIR=$PHP_MAGICKWAND
    AC_MSG_RESULT(found in $IMAGEMAGICK_DIR)
  else
    AC_MSG_CHECKING(for $MAGICK_NAME in default path)
    for i in /usr/local /usr; do
      if test -r $i/include/wand/magick-wand.h; then
        IMAGEMAGICK_DIR=$i
        AC_MSG_RESULT(found in $i)
      fi
    done

    dnl red hat has some strange locations for their imagemagick files
    dnl so here's for redhat

    if test -z "$IMAGEMAGICK_DIR"; then
      for i in /usr/local/X11R6 /usr/X11R6; do
        if test -r $i/include/X11/wand/magick-wand.h; then
          IMAGEMAGICK_DIR=$i
          AC_MSG_RESULT(found in $i)
        fi
      done
    fi
  fi

  if test -z "$IMAGEMAGICK_DIR"; then
    AC_MSG_RESULT(not found)
    AC_MSG_ERROR(Please reinstall the $MAGICK_NAME distribution -
    magick-wand.h should be in <imagemagick-dir>/include/wand/)
  fi

  MAGICKWAND_CONFIG="${CONFIG_NAME}"

  if ${IMAGEMAGICK_DIR}/bin/${CONFIG_NAME} --libs  > /dev/null 2>&1; then
    MAGICKWAND_CONFIG=${IMAGEMAGICK_DIR}/bin/${CONFIG_NAME}
  else
    if ${IMAGEMAGICK_DIR}/${CONFIG_NAME} --libs  > /dev/null 2>&1; then
       MAGICKWAND_CONFIG=${IMAGEMAGICK_DIR}/${CONFIG_NAME}
    fi
  fi

  AC_MSG_CHECKING(for ${MAGICK_NAME} ${NEEDED_VERSION_STRING} or greater with $MAGICKWAND_CONFIG)
  imagemagick_version_full=`$MAGICKWAND_CONFIG --version`
  imagemagick_version=`echo ${imagemagick_version_full} | awk 'BEGIN { FS = "."; } { printf "%d", ($1 * 1000 + $2) * 1000 + $3;}'`
  AC_MSG_RESULT($imagemagick_version_full)
  if test "$imagemagick_version" -ge ${NEEDED_VERSION}; then
    IMAGEMAGICK_LIBS=`$MAGICKWAND_CONFIG --libs`
    IMAGEMAGICK_LDFLAGS=`$MAGICKWAND_CONFIG --ldflags`    
  else
    AC_MSG_ERROR(${MAGICK_NAME} ${NEEDED_VERSION_STRING} or later is required to compile php with magickwand support)
  fi

  PHP_ADD_INCLUDE($IMAGEMAGICK_DIR/include)
  PHP_EVAL_LIBLINE($IMAGEMAGICK_LIBS, MAGICKWAND_SHARED_LIBADD)
  PHP_EVAL_LIBLINE($IMAGEMAGICK_LDFLAGS, MAGICKWAND_SHARED_LIBADD)

  AC_CHECK_LIB(${LIB_NAME},${CHECK_FUNC},
  [ 
    AC_DEFINE(HAVE_MAGICKWAND,1,[ ])
  ],[
    AC_MSG_ERROR(There is something wrong. Please check config.log for more information.)
  ],[
    $IMAGEMAGICK_LIBS -L$IMAGEMAGICK_DIR/lib $IMAGEMAGICK_LDFLAGS
  ])

  PHP_EXTENSION(magickwand, $ext_shared)
  PHP_SUBST(MAGICKWAND_SHARED_LIBADD)
fi
